=== modified file 'NEWS'
--- NEWS	2010-04-26 23:36:26 +0000
+++ NEWS	2010-04-27 06:40:39 +0000
@@ -75,9 +75,12 @@
 Testing
 *******
 
- * ``bzr selftest --parallel=subprocess`` now works correctly on win32.
+* ``bzr selftest --parallel=subprocess`` now works correctly on win32.
    (Gordon Tyler, #551332)
 
+* Workaround ``Crypto.Random`` check leading to spurious test
+  failures on Lucid, FreeBSD and gentoo.  
+  (Vincent Ladeuil, #528436)
 
 bzr 2.2b2
 #########

=== modified file 'bzrlib/tests/__init__.py'
--- bzrlib/tests/__init__.py	2010-04-23 08:51:52 +0000
+++ bzrlib/tests/__init__.py	2010-04-23 16:22:41 +0000
@@ -3201,6 +3201,19 @@
     return result
 
 
+def workaround_zealous_crypto_random():
+    """Crypto.Random want to help us being secure, but we don't care here.
+
+    This workaround some test failure related to the sftp server. Once paramiko
+    stop using the controversial API in Crypto.Random, we may get rid of it.
+    """
+    try:
+        from Crypto.Random import atfork
+        atfork()
+    except ImportError:
+        pass
+
+
 def fork_for_tests(suite):
     """Take suite and start up one runner per CPU by forking()
 
@@ -3230,6 +3243,7 @@
         c2pread, c2pwrite = os.pipe()
         pid = os.fork()
         if pid == 0:
+            workaround_zealous_crypto_random()
             try:
                 os.close(c2pread)
                 # Leave stderr and stdout open so we can see test noise

